#!/bin/bash

########################
# first argument is:
# 1 knocking on heavens door
# 2 cantonese song
# 0 rockband drums

#second argument:
# 0 no calibration
# 1 calibration enabled

# third argument (only required when running concert):
# 0 no udp waiting
# 1 udp waiting enabled
##################################


#make sure 3 arguments were passed
if [ $# -lt 2 ] || [ $# -gt 3 ]; then
	echo "Need to pass 3 or 2 arguments: $ drums.sh [song/rockband] [calibration] [udp]"
	exit
fi

song="song:="
calibration="drum_calibration:="
udp="udp:="

rockband_command="roslaunch events drum_player.launch"

chosen_command=""

# first check song
if [ $1 == "0" ]; then
	echo "---Rockband drums selected."
	 chosen_command="roslaunch events drum_player.launch"
elif [ $1 == "1" ]; then
	echo "---Knocking on heavens selected."
	song=" ${song}0"
	chosen_command="roslaunch events iros2019.launch size:=adult"
elif [ $1 == "2" ]; then
	echo "---Cantonese song selected"
	song=" ${song}1"
	chosen_command="roslaunch events iros2019.launch size:=adult"

else
	echo "-------------Invalid song"
	exit
fi

# check for drum calibration
if [ $2 == "0" ]; then
        echo "---Calibration disabled"
        calibration="${calibration}0"
elif [ $2 == "1" ]; then
        echo "---calibration enabled"
        calibration="${calibration}1"
else
        echo "-------------Invalid calibration option"
        exit
fi

#if $1 is 0 (rockband) the command is ready
if [ $1 == "0" ]; then
	command_to_execute="${chosen_command} ${calibration}"
	echo "Running command: "
	echo $command_to_execute
	eval $command_to_execute
	exit
fi


if [ $3 == "0" ]; then
        echo "---UDP waiting NOT selected"
        udp=" ${udp}0 "
elif [ $3 == "1" ]; then
        echo "---UDP waiting SELECTED"
        udp=" ${udp}1 "
else
        echo "-------------Invalid UDP Wait"
        exit
fi

#finally ready to execute the command

command_to_execute="${chosen_command} ${song} ${calibration} ${udp}"
echo "Running command: "
echo $command_to_execute
eval $command_to_execute
