# ROBOTIS-OP3

### 1. What is ROBOTIS-OP3?  
**Open Platform Humanoid Project**  
<img src="https://github.com/ROBOTIS-GIT/ROBOTIS-Documents/blob/master/wiki-images/ROBOTIS-OP3/default_op3.jpg" align="right" width="40%" />  
ROBOTIS OP3 is the latest miniature humanoid robot platform from ROBOTIS that succeeds ROBOTIS OP(aka “DARWIN OP”) and ROBOTIS OP2(aka “DARWIN 2” or “DARWIN OP2”). One of the noticeable changes of ROBOTIS OP3 is made in actuator by replacing MX-28 actuators with XM-430 actuators. Another significant change is also made in internal PC by replacing Atom based SBC(Single Board Computer) with Intel i3 based NUC. With the XM-430 which supports Dynamixel Protocol 2.0, OP3 has improved torque along with current based control and loaded with various functions. Intel NUC allows highly improved computing power that supports 64-bit OS and Bluetooth 4.1. In addition, OP3 is developed under ROS(Robot Operating System) to utilize various packages in ROS ecosystem. All these hardware improvements and ROS support allows developers to focus more on research and development compare to the preceding robots.  
  
### 2. ROBOTIS-OP3 ROS Packages
1. [ROBOTIS-OP3](https://github.com/ROBOTIS-GIT/ROBOTIS-OP3)
2. [ROBOTIS-OP3-Demo](https://github.com/ROBOTIS-GIT/ROBOTIS-OP3-Demo)
3. [ROBOTIS-OP3-msgs](https://github.com/ROBOTIS-GIT/ROBOTIS-OP3-msgs)
4. [ROBOTIS-OP3-Tools](https://github.com/ROBOTIS-GIT/ROBOTIS-OP3-Tools)
5. [ROBOTIS-OP3-Common](https://github.com/ROBOTIS-GIT/ROBOTIS-OP3-Common)
6. [DynamixelSDK](https://github.com/ROBOTIS-GIT/DynamixelSDK)
7. [ROBOTIS-Framework](https://github.com/ROBOTIS-GIT/ROBOTIS-Framework)
8. [ROBOTIS-Framework-msgs](https://github.com/ROBOTIS-GIT/ROBOTIS-Framework-msgs)
9. [ROBOTIS-Math](https://github.com/ROBOTIS-GIT/ROBOTIS-Math)  
10. [ROBOTIS-Utility](https://github.com/ROBOTIS-GIT/ROBOTIS-Utility)  
11. [face_detection](https://github.com/ROBOTIS-GIT/face_detection)   

### 3. Installation ROBOTIS OP3 ROS Packages
1. [Installing additional applications for ROBOTIS ROS Package](https://github.com/ROBOTIS-GIT/ROBOTIS-Documents/wiki/OP3-Manual-Installation#24-installing-additional-applications-for-robotis-ros-package)  
2. [Installing ROS packages for ROBOTIS-OP3](https://github.com/ROBOTIS-GIT/ROBOTIS-Documents/wiki/OP3-Manual-Installation#25-installing-ros-packages-for-robotis-op3)  
3. [Installing ROBOTIS ROS packages](https://github.com/ROBOTIS-GIT/ROBOTIS-Documents/wiki/OP3-Manual-Installation#26-installing-robotis-ros-packages)  

### 4. User's Guide
 > Reference : [e-manual](http://emanual.robotis.com/docs/en/platform/op3/getting_started/)  
 > Reference : [WIKI](https://github.com/ROBOTIS-GIT/ROBOTIS-Documents/wiki/OP3-User's-Guide)  
