#!/usr/bin/env python

from time import sleep
import rosnode
import rospy

# possible combinations
no_action = [False, False, False, False, False]
hh = [False, False, False, True, False]
hh_kick = [False, False, False, True, True]
hh_snare = [False, False, True, True, False]
ride_kick = [True, False, False, False, True]
ride_snare = [True, False, True, False, False]
ride = [True, False, False, False, False]
crash = [False, True, True, False, True]

#keep track of previous state to avoid vision bugs
previous_state = []



def play(state, control_module):
	global previous_state
	
	if state == no_action:
		print("-")

	elif state == hh:
		print("HH")
		previous_state = hh
		hh_motion(control_module)

	elif state == ride_kick:
		print("RD + Kick")
		previous_state = ride_kick
		rd_k_motion(control_module)

	elif state == previous_state:
		print('------ignore')

	elif state == hh_kick:
		print("HH + K")
		previous_state = hh_kick
		hh_k_motion(control_module)

	elif state == hh_snare:
		print("HH + Snare")
		previous_state = hh_snare
		hh_s_motion(control_module)

	elif state == ride_snare:
		print("RD + Snare")
		previous_state = ride_snare
		rd_s_motion(control_module)
	elif state == ride:
		print("RD")
		previous_state = ride
		rd_motion(control_module)

	elif state == crash:
		print("CRASH")
		previous_state = crash
		crash_motion(control_module)
	else:
		print('error')


def hh_motion(control_module):
	control_module.action().play_action("HH")


#hihat and kick motion
def hh_k_motion(control_module):
	control_module.action().play_action("HH-Kick")

#hihat and snare
def hh_s_motion(control_module):
	control_module.action().play_action("HH-Snare")

#ride and kick
def rd_k_motion(control_module):
	control_module.action().play_action("Ride-Kick")

#ride and snare
def rd_s_motion(control_module):
	control_module.action().play_action("Snare-Ride")
    
def rd_motion(control_module):
	control_module.action().play_action("Ride")

def crash_motion(control_module):
	control_module.action().play_action("Crash")