import cv2 as cv
import numpy as np

import rospy
from vision.msg import PositionArea

from base.base_object import BaseObject
from obstacles.obstacle import Obstacle


class Mixed():

    def __init__(self, marker1, marker2, module):

        self.min_area = min(marker1.min_area, marker2.min_area)
        self.max_area = marker1.max_area + marker2.max_area


    def publish_msg(self, x, y, position, area, angle, name='mixed'):
        self.pub = rospy.Publisher(
            '/vision_node/' + name, PositionArea, queue_size=1)
        
        message = PositionArea()
        message.x = x
        message.y = y
        message.position = position
        message.area = area
        message.angle = angle
        self.pub.publish(message)
